pro chopphot,no_chop=no_chop

 if strlowcase(!version.os_family) eq 'windows' then sls='\' else sls='/'

 if not keyword_set(no_chop) then begin
  f = dialog_pickfile(/mult,title='Select files to chop')
  newdir = dialog_pickfile(/dir,title='Select output directory')
  file_mkdir,newdir

  if f[0] eq '' then begin
   print,'Cancelling'
   retall
  endif

  nf = n_elements(f)
  fnew = f
  skip = intarr(nf)

  for i = 0,nf-1 do begin
   print,'Reading '+f[i]
   fits_read,f[i],im,hdr
   fntmp = strsplit(f[i],sls,/extract)
   fnew[i] = newdir+fntmp[n_elements(fntmp)-1]

   if i eq 0 then begin
    sz = size(im)
    xs = sz[1]/4 & ys = sz[2]/4
    window,0,xs=xs,ys=ys,title='Box in your region'
   endif 

   yup = ''
   while yup ne 'Yes' do begin
    tvscl,rebin(im,xs,ys)>2400<2800
    box,x1,x2,y1,y2
    yup = dialog_message(/question,'Keep this selection?')
    if yup eq 'No' then begin
     yup = dialog_message(/question,'Skip this image?')
     skip[i] = 1
    endif
   endwhile 
  
   if not skip[i] then begin
    print,'Writing '+fnew[i]
    fits_write,fnew[i],im[x1*4:x2*4,y1*4:y2*4],hdr
   endif
  endfor
  w = where(skip eq 0,nsk)
 endif else begin
  newdir = dialog_pickfile(/dir,title='Select chop directory')
  fnew = findfile(newdir+'*.fits',count=nf)
  w = lindgen(nf)
 endelse

 all = fltarr(6,2,nf)
 apr = [7,10,12,15,18,20]
 for i = 0,nf-1 do begin
  if not skip[i] then begin
   photvis,inname=fnew[i],outname=newdir+'pv_out'+strtrim(i,2)+'.prt',$
    default=[5,200,-1.,1.,.4,1.],/block
   restore,newdir+'pv_out'+strtrim(i,2)+'.prt'
   fits_read,fnew[i],im
   aper,im,pv_dat[0,*],pv_dat[1,*],mags, errap, sky, skyerr, 1, apr, skyrad, $
      /EXACT, PRINT=newdir+'aper'+strtrim(i,2)+'.prt'
   all[*,*,i] = mags
  endif
 endfor
 
 for i = 0,5 do begin
  for j = 0,1 do begin
   mo = moment(all[i,j,w],sdev=sd)
   print,strtrim(apr[i],2)+' pixel aperture for star '+strtrim(j,2)+':'+$
      strtrim(mo[0],2)+' +/- '+strtrim(sd,2)
  endfor
 endfor

end
