;+
; cosmic_clean - a generalized cosmic ray flagging system utilizing the UR IR 
;                pipeline's masking system.  The program takes input filenames, 
;                x and y pixel offsets RELATIVE TO THE FIRST GOOD IMAGE, and 
;                output filenames, and utilizes ALL available
;                data redundancy to flag and remove cosmic rays.
;
;                what's worse, it even sortof works...
;-
pro cosmic_clean,infiles,xoffsets,yoffsets,outfiles,chopsig=chopsig,sec_overlap=sec_overlap,gain=gain,nodistcorr=nodistcorr,expsz=expsz,moff=moff,pm=pm

 if not keyword_set(gain) then gain = 1.

 if not keyword_set(expsz) then expsz = 0.

 moff = [0.,0.]

 if keyword_set(sec_overlap) then begin
  nsec = n_elements(sec_overlap)
  for i = 0l,n_elements(infiles)-1l do begin
   w = where(sec_overlap eq i,nw)
   if nw eq 0 then begin
    if n_elements(main) eq 0 then main = [i] else main = [main,i]
   endif
  endfor
   
  f = infiles[main]
  f2 = infiles[sec_overlap]
;  xoff = xoffsets[[main,sec_overlap]] - xoffsets[0]
;  yoff = yoffsets[[main,sec_overlap]] - yoffsets[0]
  xoff = xoffsets[[main,sec_overlap]]
  yoff = yoffsets[[main,sec_overlap]]
 endif else begin
  f = infiles
;  xoff = xoffsets - xoffsets[0]
;  yoff = yoffsets - yoffsets[0]
  xoff = xoffsets
  yoff = yoffsets
 endelse
  
 nmos = n_elements(f)
 r = 0

;do base mosaicing
 for j = 0,nmos-1 do begin
;   if stat[i,j] eq 1 then begin
;    fits_datmask,f[i,j],slave,hdr,mask,/no_vect
  fits_datmask,f[j],slave,hdr,mask,/no_vect

  if mask[0] eq -1 then begin
   mask = finite(slave)
   w = where(mask eq 0,nbd)
   if nbd gt 0 then slave[w] = 0
   w = where(mask eq 1,ngd2)
   if ngd2 gt 0 then w2 = where(slave[w] le 0,nbd) else nbd = 0
   if nbd gt 0 then begin
    mask[w[w2]] = 0
    slave[w[w2]] = 0
   endif
  endif

  txoff = xoff[r]
  tyoff = yoff[r]
;irac only for now...  will have to get creative for ground-based stuff
  irac_expand,slave,hdr,mask,expsz
  if not keyword_set(nodistcorr) then irac_dist,slave,hdr,mask,kx,ky,expsz
  irac_spoffset,slave,hdr,mask,kx,ky,txoff,tyoff

  if n_elements(master) eq 0 then begin

;watch for this in testing
   if txoff+tyoff ne 0 then begin
    print,"master offsets weird...  What's going on, Rob??"
    retall
   endif

   sz=size(slave) & ngd = n_elements(infiles);w=where(stat[i,*] eq 1,ngd)
   imcube = fltarr(sz[1],sz[2],ngd)
   maskcube = fltarr(sz[1],sz[2],ngd)
   meds = fltarr(ngd)

   wbd = where(mask lt .1,nbd)
   if nbd gt 0 then mask[wbd] = 0
   if nbd gt 0 then slave[wbd] = 0
   meds[0] = median(slave[where(mask gt 0)])
;     meds[0] = median(slave[150:250,150:250])
;   mastermask = interp(reform(maskcube[*,*,0]),xoff[0],yoff[0])
;   master = interp(reform(imcube[*,*,0]*maskcube[*,*,0]),xoff[0],yoff[0])
   master = poly_2d(temporary(slave)*mask,kx,ky,1,missing=0)
   mastermask = poly_2d(temporary(mask),kx,ky,1,missing=0)
   wbd = where(mastermask lt .1,nbd)
   wgd = where(mastermask ge .1,ngd2)
   if nbd gt 0 then begin
    master[wbd] = 0.
    mastermask[wbd] = 0.
   endif
   if ngd2 gt 0 then master[wgd] = master[wgd]/mastermask[wgd]
   masterhdr = hdr
;   xoff = xoff+1;+xoff[0]
;   yoff = yoff+1;+yoff[0]

;save distortion-corrected stuff
   imcube[0:sz[1]-1,0:sz[2]-1,0] = master
   maskcube[0:sz[1]-1,0:sz[2]-1,0] = mastermask
   delvarx,kx,ky

  endif else begin
   wbd = where(mask lt .1,nbd)
   if nbd gt 0 then slave[wbd] = 0
   if nbd gt 0 then mask[wbd] = 0
   meds[r] = median(slave[where(mask gt 0)])
;     meds[r] = median(slave[150:250,150:250])

;   txoff = xoff[r]-round(xoff[r])
;   tyoff = yoff[r]-round(yoff[r])

;   mask = interp(reform(maskcube[*,*,r]),txoff,tyoff)
;   slave = interp(reform(imcube[*,*,r]*maskcube[*,*,r]),txoff,tyoff)
   slave = poly_2d(temporary(slave)*mask,kx,ky,1,missing=0)
   mask = poly_2d(temporary(mask),kx,ky,1,missing=0)

   wbd = where(mask lt .1,nbd)
   wgd = where(mask ge .1,ngd2)
   if nbd gt 0 then begin
    slave[wbd] = 0.
    mask[wbd] = 0.
   endif
   if ngd2 gt 0 then slave[wgd] = slave[wgd]/mask[wgd]

;save distortion-corrected stuff
   imcube[0:sz[1]-1,0:sz[2]-1,r] = slave
   maskcube[0:sz[1]-1,0:sz[2]-1,r] = mask

   mosaic_two,master,mastermask,slave,mask,txoff,tyoff,xmoff,ymoff,/autoffset

   xoff = xoff+xmoff
   yoff = yoff+ymoff
   moff = moff+[xmoff,ymoff]
   delvarx,kx,ky
  endelse
  r = r+1
;   endif
;  erase&tvimage,bytscl(master,min=0,max=4),/keep
 endfor

;  window,0,xs=800,ys=800
;stop
;  erase&tvimage,bytscl(master,min=0,max=200),/keep

; read in secondary overlap images.
 if keyword_set(sec_overlap) then begin
  for j = 0,nsec-1 do begin
   fits_datmask,f2[j],slave,hdr,mask,/no_vect
   if mask[0] eq -1 then begin
    mask = finite(slave)
    w = where(mask eq 0,nbd)
    if nbd gt 0 then slave[w] = 0
    w = where(mask eq 1,ngd2)
    if ngd2 gt 0 then w2 = where(slave[w] le 0,nbd) else nbd = 0
    if nbd gt 0 then begin
     mask[w[w2]] = 0
     slave[w[w2]] = 0
    endif
   endif

   txoff = xoff[r]
   tyoff = yoff[r]
;irac only for now...  will have to get creative for ground-based stuff
   irac_expand,slave,hdr,mask,expsz
   if not keyword_set(nodistcorr) then irac_dist,slave,hdr,mask,kx,ky,expsz
   irac_spoffset,slave,hdr,mask,kx,ky,txoff,tyoff

   slave = poly_2d(temporary(slave)*mask,kx,ky,1,missing=0)
   mask = poly_2d(temporary(mask),kx,ky,1,missing=0)

   wbd = where(mask lt .1,nbd)
   wgd = where(mask ge .1,ngd2)
   if nbd gt 0 then begin
    slave[wbd] = 0.
    mask[wbd] = 0.
   endif
   if ngd2 gt 0 then slave[wgd] = slave[wgd]/mask[wgd]

;save distortion-corrected stuff
   imcube[0:sz[1]-1,0:sz[2]-1,r] = slave
   maskcube[0:sz[1]-1,0:sz[2]-1,r] = mask
;   meds[r] = median(slave[where(mask gt 0)])

   delvarx,kx,ky
   
   r = r+1
  endfor
 endif

 sz2 = size(master)
 imcube2 = fltarr(ngd,sz2[1],sz2[2])
 maskcube2 = fltarr(sz2[1],sz2[2],ngd)

; xoff2 = fix(xoff+.99) & yoff2 = fix(yoff+.99)
 xoff2 = round(xoff) & yoff2 = round(yoff)

; imcube = imcube*maskcube

 off = fltarr(ngd)

 for j = 0,ngd-1 do begin

  imcube2[j,xoff2[j]>0:(xoff2[j]+sz[1]-1)<(sz2[1]-1),yoff2[j]>0:(yoff2[j]+sz[2]-1)<(sz2[2]-1)] = imcube[(-1.*xoff2[j])>0:(sz2[1]-1-xoff2[j])<(sz[1]-1),(-1.*yoff2[j])>0:(sz2[2]-1-yoff2[j])<(sz[2]-1),j]
  maskcube2[xoff2[j]>0:(xoff2[j]+sz[1]-1)<(sz2[1]-1),yoff2[j]>0:(yoff2[j]+sz[2]-1)<(sz2[2]-1),j] = maskcube[(-1.*xoff2[j])>0:(sz2[1]-1-xoff2[j])<(sz[1]-1),(-1.*yoff2[j])>0:(sz2[2]-1-yoff2[j])<(sz[2]-1),j]

  wbd = where(maskcube2[*,*,j] lt .1,nbd)
  wgd = where(maskcube2[*,*,j] ge .1,ngdf)

  if nbd gt 0 then begin
   tmp = maskcube2[*,*,j]
   tmp[wbd] = 0
   maskcube2[*,*,j] = tmp
   tmp = reform(imcube2[j,*,*])
   tmp[wbd] = !values.f_nan
   imcube2[j,*,*] = tmp
  endif

;redefine med, due to secondary overlap frames, and void out 
; those with rough overlap that don't actually overlap
  if ngdf gt 0 then begin 
   slop = where(mastermask[wgd] ge .1,nslop)
   tmp = reform(imcube2[j,*,*])
   if nslop gt 0 then begin
    wgd2 = wgd[slop]
    off[j] = median(tmp[wgd2])-median(master[wgd2])
;    tmp[wgd] = tmp[wgd]/(maskcube2[*,*,j])[wgd] - off[j]
    tmp[wgd] = tmp[wgd] - off[j]
   endif else begin 
    off[j] = 0
    tmp[wgd] = !values.f_nan
   endelse
    
   imcube2[j,*,*] = tmp

  endif
 endfor

 if not keyword_set(chopsig) then chopsig = 10. 
 
; imcube = imcube[1:sz[1],1:sz[2],*]
 delvarx,imcube
; maskcube = maskcube[1:sz[1],1:sz[2],*]

 ictot = reform(median_stack2(imcube2))
 mctot = total(maskcube2,3)

; ictotmean = ictot*0.
; for k=0,ngd-1 do begin
;  wdum = where(finite(imcube2[k,*,*]) eq 1)
;  ictotmean[wdum] = ictotmean[wdum]+(reform(imcube2[k,*,*]))[wdum]*(maskcube2[*,*,k])[wdum]
; endfor
; wgd = where(mctot ge .1,ngd2)
; if ngd2 gt 0 then ictotmean[wgd]=ictotmean[wgd]/mctot[wgd]

 wbd = where(mctot lt .1,nbd)
 if nbd gt 0 then begin
  ictot[wbd] = 0.
  mctot[wbd] = 0.
;  ictotmean[wbd] = 0.
 endif

 chkcube = imcube2*0.
; chkcube2 = imcube2*0.

 for j = 0,ngd-1 do begin
;  inmask = where(maskcube[*,*,j] lt .1,numbad)
  mask = where(maskcube2[*,*,j] lt .1);*mask_ptrs[i]
  wgood = where(maskcube2[*,*,j] ge .1,ngood)

;mod
  im = reform(imcube2[j,*,*])
  avg = (ictot+off[j])*gain
  avg[mask] = 0.
;  avg2 = (ictotmean+off[j])*gain
;  avg2[mask] = 0.
;  std = sqrt(avg>0)

  im[mask]=0.

  if ngood gt 0 then begin
   im[wgood] = (im[wgood]+off[j])*gain
   check = im-avg ; / (std>0.000001)
   check[mask] = !values.f_nan
   chkcube[j,*,*] = check
;   check = im-avg2
;   check[mask] = !values.f_nan
;   chkcube2[j,*,*] = check
  endif
 endfor

 chktot = reform(median_stack2(abs(chkcube)))
; chktot2 = reform(median_stack2(abs(chkcube2)))

; chktotmean = total(chkcube^2.,1,/nan)
; if ngd2 gt 0 then chktotmean[wgd] = sqrt(chktotmean[wgd]/mctot[wgd])
 
; chktotmean2 = total(chkcube2^2.,1,/nan)
; if ngd2 gt 0 then chktotmean2[wgd] = sqrt(chktotmean2[wgd]/mctot[wgd])

 if nbd gt 0 then begin
  chktot[wbd] = 0.
;  chktot2[wbd] = 0.
;  chktotmean[wbd] = 0.
;  chktotmean2[wbd] = 0.
 endif

 chkcube[where(finite(chkcube) eq 0)] = 0.

; save,ictotmean,chktot,chktotmean,chktot2,chktotmean2,chkcube,chkcube2,imcube2,maskcube2,ictot,off,gain,xoff,yoff,xoff2,yoff2,file='/mnt/net/data4/rguter/irac_work/lkha101/cos_debug.sav'
; save,f,f2,chktot,chkcube,imcube2,maskcube2,ictot,off,gain,xoff,yoff,xoff2,yoff2,file='/home/rguter/random/cos_debug.sav'
; stop

; delvarx,chkcube

; for j = 0,ngd-1 do begin
 for j = 0,nmos-1 do begin
  fits_datmask,f[j],oldim,oldhdr,oldmask,/no_vect

  if oldmask[0] eq -1 then begin
   oldmask = float(finite(oldim))
  endif

  wcrap = where(oldmask ge 0.1,ncrap)

  if ncrap gt 0 then begin
;   wbd = where(maskcube2[*,*,j] lt .1,nbad)
   outmask = oldmask
   if not keyword_set(pm) then check = smooth(reform(chkcube[j,*,*]) - chopsig*chktot,3) else check = smooth(reform(abs(chkcube[j,*,*])) - chopsig*chktot,3)

;  inmask = where(maskcube[*,*,j] lt .1,numbad)
;  mask = where(maskcube2[*,*,j] lt .1);*mask_ptrs[i]
;  wgood = where(maskcube2[*,*,j] ge .1,ngood)

;mod
;  im = reform(imcube2[j,*,*])
;  avg = ictot+off[j]
;  avg = (ictot+off[j])*gain
;  chktot2 = chktot
;  avg[mask] = 0.
;  chktot2[mask] = 0.
;  std = sqrt(avg>0)

;  im[mask]=-10000
;  wgood = where(im ne -10000,ngood)
;  im[mask]=0.

;  if ngood gt 0 then begin
;   im[wgood] = im[wgood]/(maskcube2[*,*,j])[wgood]
;   im[wgood] = im[wgood]+off[j]
;   im[wgood] = (im[wgood]+off[j])*gain
;   check = ((abs(im-avg) / (std>0.000001))-chktot2)>0
;   check = abs(im-avg) / (std>0.000001) - (chktot2)
;   check[mask]=0.
;
;replicate skysclim.pro with mask included
;   idx=randomu(seed,min([10000,n_elements(im)-numbad]))*(n_elements(im)-numbad-1)
;   robomean,check[wgood[idx]],2.0,0.5,meanval,dummy,rsig
;   robomean,check[wgood],2.0,0.5,meanval,dummy,rsig
;and pray that this works...

;flagging condition
;   check = temporary(check)/rsig

;  erase&tvimage,bytscl(check,min=0,max=chopsig),/keep,pos=pos

;   wbd = where(check gt chopsig,nbd) ; only positive transients?

   wbd = where(check gt 0,nbd)
    
; stop

   if nbd gt 0 then begin
    xbd = (wbd mod sz2[1]) - xoff2[j] ;+ round(xoff[j])
    ybd = (wbd / sz2[1]) - yoff2[j] ;+ round(yoff[j])

    xbd = [xbd,xbd,xbd,xbd+1,xbd+1,xbd+1,xbd-1,xbd-1,xbd-1]
    ybd = [ybd,ybd+1,ybd-1,ybd,ybd+1,ybd-1,ybd,ybd+1,ybd-1]

;    plot,xbd+xoff2[j]-round(xoff[j]),ybd+yoff2[j]-round(yoff[j]),psym=3,color=255l,pos=pos,/noerase,xran=[0,sz2[1]-1],yran=[0,sz2[2]-1],/xsty,/ysty
    w2 = where(xbd ge 0 and xbd le sz[1]-1 and ybd ge 0 and ybd le sz[2]-1,n2)

    imtmp = oldim & masktmp = oldim & hdrtmp = oldhdr
    tsz = size(oldim)
    irac_expand,imtmp,hdrtmp,masktmp,expsz
    if not keyword_set(nodistcorr) then irac_dist,imtmp,hdrtmp,masktmp,kx,ky,expsz
    txoff = xoff[j]  &  tyoff = yoff[j]
    irac_spoffset,imtmp,hdrtmp,masktmp,kx,ky,txoff,tyoff

    if n2 gt 0 then begin
     xbd = xbd[w2]  & ybd = ybd[w2]
     xbd2 = float(xbd)*0.  & ybd2 = float(ybd)*0.
     for g = 0,2 do begin
      for h = 0,2 do begin
       xbd2 = xbd2 + xbd^float(h)*ybd^float(g)*kx[g,h]
       ybd2 = ybd2 + xbd^float(h)*ybd^float(g)*ky[g,h]
      endfor
     endfor
     delvarx,kx,ky

     xbd2 = round(xbd2) & ybd2 = round(ybd2)
      
     w2 = where(xbd2 ge expsz and xbd2 le tsz[1]-1+expsz and ybd2 ge expsz and ybd2 le tsz[2]-1+expsz,n2) 
     if n2 gt 0 then begin
      newmask = (ybd2[w2]-expsz)*tsz[1]+xbd2[w2]-expsz
;      outmask = merge_mask(newmask,oldmask)
      outmask[newmask] = 0
;     print,'Mean/Sig of check:',meanval,rsig
      wcrap2 = where(outmask ge .1,ncrap2) 
      print,'Filtered Pixels:',ncrap - ncrap2
     endif
    endif
   endif

 ;  if n_elements(outmask) gt n_elements(oldmask) then outmask[newmask] = 0
   fits_datmask,/write,outfiles[j],oldim,oldhdr,outmask
   delvarx,newmask
  endif else begin
;   fits_datmask,infiles[j],im,hdr,outmask
;   outmask = reform(maskcube[*,*,j])
;   if n_elements(inmask) gt numbad then outmask[newmask] = 0
   fits_datmask,/write,outfiles[j],oldim,oldhdr,oldmask
  endelse
 endfor

;  erase&tvimage,bytscl(ictot,min=0,max=200),/keep
  
end
