
pro pv_modsession

 inname=dialog_pickfile(title='Select PhotVis Session to Modify',/must_exist)
 if inname eq '' then begin
  huh = dialog_message(/info,'PhotVis session modify cancelled...')
  return
 endif

 fname = dialog_pickfile(/write,$
                         title='Save Modified PhotVis Session (IDL "SAVE") As')
 if fname eq '' then begin
  huh = dialog_message(/info,'PhotVis session modify cancelled...')
  return
 endif
 if file_test(fname) then begin
  huh = dialog_message(/question,'File Exists: Overwrite selected file?')
  if huh eq 'No' then return
 endif

 restore,inname
 
 if n_elements(valid) lt 1 then begin
  huh = dialog_message('ERROR: Invalid PhotVis session file!')
  return
 endif
 
 if not file_test(im_name) then begin
  huh = dialog_message('No FITS file called '+im_name+'!')
  im_name = dialog_pickfile(/must_exist,get_path=newpath,$
     path=path,title='PhotVis: Select FITS Image')
  if im_name eq '' then begin
   huh = dialog_message(/info,'PhotVis session restore cancelled')
   return
  endif
  path = newpath
 endif
 fits_datmask,im_name,im,hdr,mask

;for now, just flip in x and y, AKA 180 degree rotation, cuz that's what i need

 im = rotate(temporary(im),2)
 if (size(mask))[0] eq 2 then mask = rotate(temporary(mask),2)

 im_name = dialog_pickfile(get_path=newpath,$
     path=path,title='Save modified FITS Image as')
 if im_name eq '' then begin
  huh = dialog_message(/info,'PhotVis session restore cancelled')
  return
 endif
 if file_test(im_name) then begin
  huh = dialog_message(/question,'File Exists: Overwrite selected file?')
  if huh eq 'No' then return
 endif

 path = newpath
 
 if n_elements(find_dat) gt 0 then begin
  find_dat[0,*] = n_elements(im[*,0]) - find_dat[0,*] - 1
  find_dat[1,*] = n_elements(im[0,*]) - find_dat[1,*] - 1
  sfind_dat = ',find_dat'
 endif else return

 fits_datmask,im_name,im,hdr,mask,/write

 main_save = 'save,file=fname,path,plot_state,plot_params,find_state,valid,'+$
    'find_params,find_defaults,aper_defaults,active_obj,n_objects,centerboxsize'

 if n_elements(im_name) gt 0 then begin
  sim_name = ',im_name'
 endif else sim_name = ''

 if n_elements(im_scl) gt 0 then begin
  sim_scl = ',im_scl'
 endif else sim_scl = ''

 if n_elements(find_status) gt 0 then begin
  sfind_status = ',find_status'
 endif else sfind_status = ''

 if n_elements(aper_dat) gt 0 then begin
  saper_dat = ',aper_dat'
 endif else saper_dat = ''

 test = execute(main_save+sim_name+sim_scl+sfind_dat+sfind_status+saper_dat)

 if test then huh = dialog_message(/info,'PhotVis session saved successfully!')$
    else huh = dialog_message('ERROR!  PhotVis session not saved!')

end
