
pro quick_sky

 infil = dialog_pickfile(/multiple,title='Select images for median sky frame')
 
 if infil[0] ne '' then begin
  nf = n_elements(infil)

  for i = 0,nf-1 do begin
   print,'Reading '+infil[i]
   fits_read,infil[i],im 
   if i eq 0 then begin
    sz = size(im)
    cube = ptr_new(make_array(nf,sz[1],sz[2],type=sz[sz[0]+1],/nozero),$
       /no_copy)
    meds = fltarr(nf)
   endif 

   meds[i] = median(im)
   (*cube)[i,*,*] = temporary(im)
  endfor

  med = median(*cube)

  for i = 0,nf-1 do (*cube)[i,*,*] = (med-meds[i])+temporary((*cube)[i,*,*])

  result = xmedian_stack(cube)
  ptr_free,cube

  yup = 'No'
  while yup eq 'No' do begin  
   new = dialog_pickfile(title='Save flatted median skyframe as?')
   if file_test(new) then yup = dialog_message(/question,'File '+new+$
      ' exists...  Overwrite?') else yup = 'Yes'
   if new eq '' then yup = ''
  endwhile

  sxaddpar,hdr,'HISTORY','flatted sky frame; median of '+strtrim(nf,2)+$
     ' images'
  if yup eq 'Yes' then begin
   print,'Writing '+new
   fits_write,new,*result,hdr
  endif else print,'Cancelling...'
  ptr_free,result
 endif else print,'Cancelling...'
end
