
;+
;
; rob_reassemble: trying to take offsets and remake mosaics automatically
;
; shouldn't be too hard, right?  >;-P
;
;-

pro rob_reassemble,indir=indir

 if not keyword_set(indir) then indir=dialog_pickfile(/must_exist,$
    /directory,title='Select rob_assemble mosaic directory')

;multi-platform capability
 if strlowcase(!version.os_family) eq 'windows' then sls = '\' else sls = '/'

 if indir eq '' then retall
 if strmid(indir,strlen(indir)-1,1) ne sls then indir = indir+sls
 restore,indir+'rob_assemble.sav'

 nf = n_elements(f)

;multi-platform capability part two
 if strlowcase(!version.os_family) eq 'windows' then sls2 = '' else $
    if strmid(f[0],0,1) eq sls then sls2 = sls else sls2 = ''

 temp = strsplit(f[0],sls,/extract)
 ntmp = n_elements(temp)
 if ntmp gt 1 then begin
  for i=0l,nf-1 do begin
   temp = strsplit(f[i],sls,/extract)
   ntmp = n_elements(temp)
   f[i] = temp[ntmp-1]
  endfor
 endif
 f = indir+'../'+f

 tmp = findfile(indir+'sm_offsets*',count=ntmp)
 offnm = tmp
 for i = 0,ntmp-1 do begin
  str = 'sm_offsets'+strtrim(i,2)+'_f_' & strl = strlen(str)
  w = where(strmid(tmp,strlen(indir),strl) eq str)
  offnm[i] = tmp[w[0]]
 endfor

 npm = n_elements(f[*,0])
 nmos = n_elements(f[0,*])

 if n_elements(ind) eq 0 then ind = indgen(npm)

 smnm = indir+'submosaic'+strtrim(lindgen(ntmp),2)+'.fits'
 mainnm = indir+'final_mosaic.fits'
 mainoff = (findfile(indir+'final_offsets*'))[0]
 rejfile = indir+'rejects.txt'
 stat = lonarr(npm,nmos)+1
 if file_test(rejfile) then begin
  rejects = loadlist(rejfile)
  for i=0,n_elements(rejects)-1 do begin
   w=where(f eq rejects[i],nrej)
   if nrej gt 0 then stat[w[0]]=0
  endfor
 endif

 for l = 0,npm-1 do begin

  i = ind[l]

  print,'reading '+offnm[i]
  openr,one,offnm[i],/get
  sl = strlen(offnm[i])
  us = rstrpos(offnm[i],'_')
  num = fix(strmid(offnm[i],us+1,sl-us-1))
  offsets=fltarr(2,num/2)
  readu,one,offsets
  xoff = reform(offsets[0,*])
  yoff = reform(offsets[1,*])
  xmoff = 0.& ymoff = 0.
  free_lun,one
  r = 0

  for j = 0,nmos-1 do begin
   if stat[i,j] eq 1 then begin
    fits_datmask,f[i,j],slave,hdr,mask,/no_vect
    w = where(mask lt .1,nbad)
    if nbad gt 0 then begin
     slave[w] = median(slave)
     mask[w] = 0.
    endif
    if n_elements(master) eq 0 then begin
     master = slave
     mastermask = mask
     masterhdr = hdr
    endif else begin
     mosaic_two,master,mastermask,slave,mask,xoff[r],yoff[r],xmoff,ymoff,/autoffset
     xoff = xoff+xmoff
     yoff = yoff+ymoff
    endelse
    r = r+1
   endif
  endfor

  print,'writing '+smnm[i]
  fits_datmask,/write,smnm[i],master,masterhdr,mastermask
  delvarx,master,mastermask,masterhdr

 endfor

 openr,one,mainoff,/get
 offsets=fltarr(2,npm)
 readu,one,offsets
 xoff = reform(offsets[0,*])
 yoff = reform(offsets[1,*])
 xmoff = 0.& ymoff = 0.
 free_lun,one
 r = 0

 for l = 0,npm-1 do begin
  i = ind[l]
;  i = indgen(npm)
  fits_datmask,smnm[i],slave,hdr,mask
  if n_elements(master) eq 0 then begin
   master = slave
   mastermask = mask
   masterhdr = hdr
  endif else begin
   mosaic_two,master,mastermask,slave,mask,xoff[r],yoff[r],xmoff,ymoff,/autoffset
   xoff = xoff+xmoff
   yoff = yoff+ymoff
  endelse
  r = r+1
 endfor

 fits_datmask,/write,mainnm,master,masterhdr,mastermask

end

