
function slideshow2,select=select,scl=scl,moremask=moremask,infiles=infiles,gscl=gscl

 if strlowcase(!version.os_family) eq 'windows' then sls='\' else sls='/'

 if not keyword_set(scl) then scl = 1

 if not keyword_set(gscl) then gscl = [.9,1.1]

 if not keyword_set(infiles) then infiles = dialog_pickfile(/multiple,title='Select FITS Files for Slideshow')

 if infiles[0] ne '' then begin
  nf = n_elements(infiles)

  for i = 0,nf-1 do begin
   fits_datmask,infiles[i],im,hdr,mask
   if keyword_set(moremask) then mask=merge_mask(temporary(mask),moremask)

   med = median(im)
   if mask[0] ne -1 then im[mask] = med
   if keyword_set(select) then im = im[select[0]:select[1],select[2]:select[3]]

   if i eq 0 then begin
    szim = size(im)
    xs = fix(szim[1]/scl) & ys = fix(szim[2]/scl)
    window,0,xs=xs,ys=ys+10
    movie = bytarr(xs,ys+10,nf,/nozero)
   endif 
   
   erase
   tv,bytscl(congrid(im,xs,ys)/med,min=gscl[0],max=gscl[1])
   xyouts,fix(xs/2),ys,strmid(infiles[i],rstrpos(infiles[i],sls)+1,$
      strlen(infiles[i])-rstrpos(infiles[i],sls)-1),align=.5,/dev
 
   movie[*,*,i] = tvrd()

  endfor
  return,movie
 endif else begin
  print,'Cancelling...'
  return,-1
 endelse

end
