
; converts RA-Dec pvdats to X-Y using WCS 

pro wcs_pvd2,pvdname=pvdname,fitsname=fitsname,outname=outname

 if not keyword_set(pvdname) then pvdname = dialog_pickfile(title='Select PV_DAT file',/must_exist)
 if pvdname eq '' then begin
  print,'Cancelled...'
  retall
 endif
 if not keyword_set(fitsname) then fitsname = dialog_pickfile(title='Select FITS file with accurate WCS',/must_exist)
 if fitsname eq '' then begin
  print,'Cancelled...'
  retall
 endif
 if not keyword_set(outname) then outname = dialog_pickfile(title='Save WCS-based PV_DAT file as')
 if outname eq '' then begin
  print,'Cancelled...'
  retall
 endif

 restore,pvdname
 fits_read,fitsname,im,hdr,/header_only

 pv_dat = double(pv_dat)
 adxy,hdr,pv_dat[0,*],pv_dat[1,*],x,y
 pv_dat[0,*] = x
 pv_dat[1,*] = y

 save,pv_dat,file=outname 

end
