
; where_overlap - returns indeces of images that overlap the current submosaic
;
; expectation is for inputs to already be sorted ala irac_sort_data.pro, etc.
;
; assume all images are the same size and rotation, ignore distortion for now

function where_overlap,infiles,xoffsets,yoffsets,which_submos,nresult,rejects=rejects

 sz = size(infiles)
 if not keyword_set(rejects) then rejects = bytarr(sz[1],sz[2])
 wgd = where(rejects[*,which_submos] eq 0b)

 fits_read,infiles[wgd[0],which_submos],im,hdr,/header_only
 imsz = sxpar(hdr,'NAXIS*')
 smsz = imsz
; xbase = xoffsets[wgd[0],which_submos]
; ybase = yoffsets[wgd[0],which_submos]
 xbase = min(xoffsets[wgd,which_submos])
 ybase = min(yoffsets[wgd,which_submos])
 xoff = xoffsets-xbase
 yoff = yoffsets-ybase

 smsz[0] = imsz[0]+max((xoff[wgd,which_submos])>0);-min((xoff[wgd,which_submos])<0) 
 smsz[1] = imsz[1]+max((yoff[wgd,which_submos])>0);-min((yoff[wgd,which_submos])<0) 

 for j = 0l,sz[2]-1l do begin
  if j ne which_submos then begin
   wgd = where(rejects[*,j] eq 0b)
   w = where((xoff[wgd,j]+imsz[0]-1 ge 0 and xoff[wgd,j] le smsz[0]-1) and $
             (yoff[wgd,j]+imsz[1]-1 ge 0 and yoff[wgd,j] le smsz[1]-1),ngd)
   if ngd gt 0 then begin
    if n_elements(result) eq 0 then result = wgd[w]+sz[1]*j else $
       result = [result,wgd[w]+sz[1]*j]
   endif
  endif
 endfor

 nresult = n_elements(result)
 if nresult eq 0 then result = -1

 return,result

end
