;+
;   name:
;       jail.pro
;
;   purpose:
;       for Mt. Hopkins STELIRCAM data only!!!  to get rid of the
;       vertical "jailbars" that appear in the data every 4th readout
;
;   calling sequence:
;       this program is called by linfind.pro and is not used alone
;
;   history:
;       writtten 7-18-00: S. T. Megeath
;
;-


function jail,data

  ndata = data
  amp1 = rebin(data,64,256,/sample)
  amp2 = rebin(shift(data,-1,0),64,256,/sample)
  amp3 = rebin(shift(data,-2,0),64,256,/sample)
  amp4 = rebin(shift(data,-3,0),64,256,/sample)
  med1 = median(amp1)
  med2 = median(amp2)
  med3 = median(amp3)
  med4 = median(amp4)
  median = median([med1,med2,med3,med4])
  for i = 0,63 do begin
    ndata[i*4,*] = amp1[i,*]+median-med1
    ndata[i*4+1,*] = amp2[i,*]+median-med2
    ndata[i*4+2,*] = amp3[i,*]+median-med3
    ndata[i*4+3,*] = amp4[i,*]+median-med4
  endfor
 
  return,ndata
end
