;...............................................................
;
; 	integrate cube in b
;
;...............................................................

function int_slice_b,cube,b,b1=b1,b2=b2,order=order,clip=clip

if NOT keyword_set(order) then order = "vxy"


if keyword_set(clip) then begin
   cube = cube * (cube gt clip)
endif


sum = 0
diff = abs(b[1]-b[0])
coord1 = 0
coord2 = n_elements(b)-1
;cube = cube * (cube gt .3)
for i = 0,n_elements(b)-1 do begin
  if (abs(b1-b[i]) le diff/2) then coord1 = i
  if (abs(b2-b[i]) le diff/2) then coord2 = i
endfor

  pixmin = coord1 < coord2
  pixmax = coord2 > coord1
  pixmin = pixmin > 0
  pixmax = pixmax < n_elements(b)-1

;depending on order of x, y, and v, sum over all velocity channels
  case order of
    "vxy": sum = total(cube[*,*,pixmin:pixmax],3)
    "xvy": sum = total(cube[*,*,pixmin:pixmax],3)
    "xyv": sum = total(cube[*,pixmin:pixmax,*],2)
  endcase
  
;convert units to T_a * db(degree)
  sum = sum*diff
  print,"max sum =",max(sum)

return,sum
end



