pro tv2ps,filename,margin=margin

; load in data
    tv = tvrd()
    im_asp = (1.0*!D.y_vsize)/!D.y_vsize

; set up margin
   if NOT keyword_set(margin) then margin = 0.1

; initialize pos_array
   pos_array = replicate(0.,4)

; find device name
   dev = !d.name 

; set up postscript parameters
    dpcm=1000.                      ; dots/cm
    xpaper=21.6                     ; xsize of paper (cm)
    ypaper=27.9                     ; ysize of paper (cm)
    xmargin=2.5                     ; x-border (cm)
    ymargin=2.5                     ; y-border (cm)
    xoffset = xmargin/2.
    yoffset = ymargin/2.
    set_plot,'ps'
    device,/portrait,xoff=xoffset,yoff=yoffset,xsize=xpaper,ysize=ypaper,$
          filename=filename,encapsulate=0
    device,/color,bits=8
    plot,findgen(!D.x_vsize),findgen(!D.y_vsize),xsty=5,ysty=5,/noerase,/nodata


; set up initial value for display size, pixel size, and aspect ratio
    xdisp = xpaper-xmargin
    ydisp = ypaper-ymargin
    disp_asp =  ydisp/xdisp
    if NOT keyword_set (nomatch) then begin
     aspect = im_asp
     endif else begin
     aspect = disp_asp
    endelse

; set size of plots and margin of plot grid
    if (disp_asp gt aspect) then begin
      xpsize = ((1.-margin)*xdisp)
      ypsize = (aspect*xpsize)
      marginx = (margin/2.*xdisp)
      marginy = (ydisp-ypsize)/2.
    endif else begin
      ypsize = ((1.-margin)*ydisp)
      xpsize = (ypsize/aspect)
      marginy = (margin/2.*ydisp)
      marginx = (xdisp-xpsize)/2.
    endelse

; create a position array of the corners of each plot panel
   pos_array[*] = [marginx,marginy,marginx+xpsize,marginy+ypsize]
   pos_array = pos_array*dpcm

   tv,tv,pos_array[0],pos_array[1],xsize=xpsize*dpcm,ysize=ypsize*dpcm

   device,/close
   set_plot,dev

   return
end

