;------------------------------------------------------------------
;
; 	clustergrid
;
;
;	NOTE: the definition of nrows, ncolumns, dcols, drows is switched between
;	      this program and clustergrid_tri
;
;
;	S. T. Megadeath 4-8-00
;       modified on 4-07-05 to have a cluster grid
;
;
;------------------------------------------------------------------

function clustergrid,datafile,x,y,nrows,ncolumns,drows,dcols,rot,row_off=row_off,col_off=col_off

   posang = rot*2.*3.14159624/360.
   coords = fltarr(2,nrows*ncolumns)
   drows = drows/3600.
   dcols = dcols/3600.

   roff = 0
   coff = 0
   if keyword_set(row_off) then roff=row_off
   if keyword_set(col_off) then coff=col_off
   roff = roff/3600.
   coff = coff/3600.

   for i = 0,nrows-1 do begin
      for j = 0,ncolumns-1 do begin
   	coords[0,j+i*ncolumns] = drows*i-(nrows-1)*drows/2.+roff
   	coords[1,j+i*ncolumns] = dcols*j-(ncolumns-1)*dcols/2.+coff
      endfor
   endfor

   rotcoords = coords
   rotcoords[0,*] =  coords[0,*]*cos(posang)+coords[1,*]*sin(posang)
   rotcoords[0,*] = rotcoords[0,*]/cos(y*2.*3.14159624/360.)+x
   rotcoords[1,*] =  coords[1,*]*cos(posang)-coords[0,*]*sin(posang)+y

   openw,1,datafile
   printf,1,rotcoords
   close,1
   return,rotcoords

end
