;------------------------------------------------------------------------
;
; 	clustergrid_tri
;
;	this program creates a "triangular" grid of mapping
;	positions needed to create a cluster aor.
;
;	IMPORTANT: nrows1 must equal nrows2+1, 
;		   ncolumns1 must equal ncolumns2+/-1
;
;	NOTE: the definition of nrows, ncolumns, dcols, drows is switched 
;	      between this program and clustergrid.
;
;	S. T. Megadeath 3-24-02
;
;-------------------------------------------------------------------------


function clustergrid_tri,datafile,x,y,ncolumns1,ncolumns2,nrows1,nrows2,$
	 dcols,drows,rot

   direction=1

   posang = rot*2.*!pi/360.
   coords = dblarr(2,nrows1*ncolumns1+nrows2*ncolumns2)
   drows = drows/3600.
   dcols = dcols/3600.

; create unrotated coordinates for all but the last row
   case direction of 
    1: begin
     for i = 0,nrows1-2 do begin
       for j = 0,ncolumns1-1 do begin
   	 coords[0,j+i*ncolumns1+i*ncolumns2] = dcols*j-(ncolumns1-1)*dcols/2.
   	 coords[1,j+i*ncolumns1+i*ncolumns2] = drows*i-(nrows1-1)*drows/2.
       endfor
       for j = ncolumns2-1,0,-1 do begin
;       for j = 0,ncolumns2-1 do begin
	 ;print,j
   	 coords[0,j+i*ncolumns2+(i+1)*ncolumns1] = -1.*(dcols*j-(ncolumns2-1)*dcols/2.)
   	 coords[1,j+i*ncolumns2+(i+1)*ncolumns1] = (drows*i-(nrows2-1)*drows/2.)
       endfor
     endfor

; finish last row
     for j = 0,ncolumns1-1 do begin
       coords[0,j+(nrows1-1)*ncolumns1+(nrows2)*ncolumns2] = dcols*j-(ncolumns1-1)*dcols/2.
       coords[1,j+(nrows1-1)*ncolumns1+(nrows2)*ncolumns2] = drows*i-(nrows1-1)*drows/2.
     endfor
    end
   endcase

   rotcoords = coords
   rotcoords[1,*] =  coords[1,*]*cos(posang)-coords[0,*]*sin(posang)+y
   rotcoords[0,*] =  coords[0,*]*cos(posang)+coords[1,*]*sin(posang)
   rotcoords[0,*] = rotcoords[0,*]/cos(rotcoords[1,*]*2.*3.14159624/360.)+x

   openw,1,datafile
   printf,1,rotcoords
   close,1
   return,rotcoords

end
