;------------------------------------------------------------
;
;	mipsscan
;
;	this program overlays a mips scanmap FOV onto images displayed
;	with disp_image.  It assumes that the x,y coordinates
;	are in RA,Dec with units of degrees.
;
;	x = RA in decimal degrees
;       y = Dec in decimal degrees
;       rot = position angle in degrees
;
;	S. T. Megadeath (4-5-00) 
;
;	last modified 4-11-00
;
;-------------------------------------------------------------

pro mipscan,x,y,posangle,scanlength,delta_cross,number_cross,$
    radec=radec

  rot = posangle
  cos = 1.

  if keyword_set(radec) then cos = 1./cos(2.*3.14159264*y/360.)

; define rotation angle in radians and edges of scan map in
; arcminutes
  rot = 2*3.14159264/360.*(rot)
  width = delta_cross*number_cross
  xmap = [-width/2.,width/2.,width/2.,-width/2.,-width/2.]
  ymap = $
  [-scanlength/2.,-scanlength/2.,scanlength/2.,scanlength/2.,-scanlength/2.]

; convert units into degress
  xmap = xmap/60.
  ymap = ymap/60.

  print,xmap,ymap
; rotate
  xrot = xmap*cos(rot)+ymap*sin(rot)
  yrot = ymap*cos(rot)-xmap*sin(rot)

  oplot,cos*xrot+x,yrot+y,psym=0,color=255,thick=4

end
