
function distmatch,tol=tol,dataname=dataname,stdname=stdname,stdoff=stdoff

 if not keyword_set(tol) then tol = 15.
 nf = 2

 data = ptrarr(nf,/alloc)

 if not keyword_set(dataname) then $
    dataname = dialog_pickfile(title='Select Data PV_DAT file',/must_exist)
 
 if dataname eq '' then begin
  print,'Cancelled...'
  retall
 endif
 restore,dataname
 pv_dat = pm_filter(temporary(pv_dat),tol)
 if pv_dat[0] eq -1 then retall
 *data[0] = temporary(pv_dat)

 if not keyword_set(stdname) then $
    stdname = dialog_pickfile(title='Select Standards PV_DAT file',/must_exist)
 if stdname eq '' then begin
  print,'Cancelled...'
  retall
 endif
 restore,stdname
 pv_dat = pm_filter(temporary(pv_dat),tol)
 if pv_dat[0] eq -1 then retall
 if keyword_set(stdoff) then begin
  pv_dat[0,*] = pv_dat[0,*]+stdoff[0]
  pv_dat[1,*] = pv_dat[1,*]+stdoff[1]
 endif
 *data[1] = temporary(pv_dat)

 sz = size(*data[0])
 k = 0

 for i = 0,sz[2]-1 do begin

  x = (*data[0])[0,i]
  y = (*data[0])[1,i]
  gdflg = 0
  xtmp = fltarr(nf) & ytmp = fltarr(nf)
  xtmp[0] = x  & ytmp[0] = y

  for j = 1,nf-1 do begin
   dist = sqrt(((*data[j])[0,*]-x)^2+((*data[j])[1,*]-y)^2)
   md = min(dist)
   if md lt tol then gdflg = gdflg+1
   w = (where(dist eq md))[0]
   xtmp[j] = (*data[j])[0,w]
   ytmp[j] = (*data[j])[1,w]
  endfor

  if gdflg eq nf-1 then begin

   if k eq 0 then out = [xtmp[0],ytmp[0],xtmp[1],ytmp[1]] else begin
    temp = temporary(out)
    out = fltarr(4,k+1,/nozero)
    out[*,0:k-1] = temporary(temp)
    out[*,k] = [xtmp[0],ytmp[0],xtmp[1],ytmp[1]]
   endelse

   k = k+1
  endif
 endfor

 return,out

end

