;+
;   name:
;       jail.pro
;
;   purpose:
;       for Mt. Hopkins STELIRCAM data only!!!  to get rid of the
;       vertical "jailbars" that appear in the data every 4th readout
;
;   calling sequence:
;       this program is called by linfind.pro and is not used alone
;
;   history:
;       writtten 7-18-00: S. T. Megeath
;
;-


function jail2,data

  ndata = data

  for i = 0,63 do begin
    meds = [median(data[i*4,*]),median(data[i*4+1,*]),$
            median(data[i*4+2,*]),median(data[i*4+3,*])]
    med = median(meds)
    ndata[i*4,*] = data[i*4,*]+med-meds[0]
    ndata[i*4+1,*] = data[i*4+1,*]+med-meds[1]
    ndata[i*4+2,*] = data[i*4+2,*]+med-meds[2]
    ndata[i*4+3,*] = data[i*4+3,*]+med-meds[3]
  endfor
 
  return,ndata
end
