
pro rob_assfix,infiles=infiles,order=order,npm=npm,no_mos=no_mos,mosdir=mosdir

 if not keyword_set(infiles) then infiles=dialog_pickfile(/multiple,/must_exist,title='Select FITS files')
 nf = n_elements(infiles)
 if not keyword_set(npm) then npm=9

 ;multi-platform capability
 if strlowcase(!version.os_family) eq 'windows' then begin
  sls = '\'
  sls2 = ''
 endif else begin
  sls = '/'
  if strmid(infiles[0],0,1) eq sls then sls2 = sls else sls2 = ''
 endelse

 temp = strsplit(infiles[0],sls,/extract)
 ntmp = n_elements(temp)
 if ntmp gt 1 then sdir = sls2+strjoin(temp[0:n_elements(temp)-2],sls)+sls $
    else sdir = '.'+sls

 ;get filter from master header
 if not keyword_set(mosdir) then begin
  fits_read,infiles[0],im,hdr,/header_only
  filter = strmid(sxpar(hdr,'FILTER',count=np),0,1)
  if np eq 0 then filter = ''

  mdir = sdir+filter+'mosaic'+sls
 endif else begin
  mdir = mosdir
 endelse

 f = infiles
 nmos = nf/npm

 ;arrange filenames into 2D array
 if keyword_set(no_mos) then begin
  ftmp = f
  f = strarr(nmos,npm)
  for i = 0,nmos-1 do f[i,*] = ftmp[0+i*npm:npm-1+i*npm]
  npmtmp = npm
  npm = nmos
  nmos = npmtmp
 endif else begin
  f = reform(f,npm,nmos,/overwrite)
 endelse

 if not keyword_set(order) then order=indgen(npm)
 ind = order
 save,file=mdir+'rob_assemble.sav',f,ind

end
