
pro shrink1,scl

;multi-platform capability
  case strupcase(!version.os_family) of
   'UNIX': sls = '/'
   'WINDOWS': sls = '\'
   else: begin
    print,'ERROR in slideshow.pro: only works under Windows and Unix'
    retall
   end
  endcase

;indir = rob_pf(/directory,title='Select Directory with FITS Images')
inf = dialog_pickfile(/multiple,title='Select FITS Images')
ninf = n_elements(inf)
;inf = findfile(indir+'*?.fits',count=ninf)

outdir = rob_pf(/directory,title='Select Destination Directory')
if not file_test(outdir) then file_mkdir,outdir

if ninf eq 0 or inf[0] eq '' then return

for i = 0,ninf-1 do begin
 
 print,'Reading '+inf[i]+' ...'
 fits_read,inf[i],im,hdr
 sz = size(im)

 im = congrid(temporary(im),sz[1]/scl,sz[2]/scl)

 fn = strmid(inf[i],rstrpos(inf[i],sls)+1,strlen(inf[i])-rstrpos(inf[i],sls)-1)

 print,'Writing '+outdir+fn+' ...'
 fits_write,outdir+fn,im,hdr

endfor

print,'Shrinking complete!'

end
