
function pv_fwhm_report,infile=infile,display=display

 if strlowcase(!version.os_family) eq 'windows' then sls=['','\'] else sls=['','/']

;uncertainty threshold for chucking a star...  
 if not keyword_set(ethresh) then ethresh = .2

;use photvis session file!  much easier! 
 if not keyword_set(infile) then fn=dialog_pickfile(title='Select PhotVis session file',/must) else fn=infile
 if fn eq '' then retall
 restore,fn
; if not file_test(im_name) then begin
 tmp = strsplit(im_name,sls[1],/extract)
 tmp2 = strsplit(fn,sls[1],/extract)
 fnm = (strsplit(tmp2[n_elements(tmp2)-1],'.',/extract))[0]+'.fits'
 im_name = sls[(strmid(fn,0,1) eq sls[1])]+strjoin(tmp2[0:n_elements(tmp2)-2],sls[1])+sls[1]+fnm
; endif

 if not file_test(im_name) then begin
  huh = dialog_message('No FITS file called '+im_name+'!')
  im_name = dialog_pickfile(/must_exist,get_path=newpath,$
     title='PhotVis: Select FITS Image')
  if im_name eq '' then begin
   huh = dialog_message(/info,'PhotVis session restore cancelled')
   return,-1
  endif
 endif

 fnm = im_name
 mzp = aper_defaults[4]
 fwhm=find_params[0]
 ithresh = find_params[1]
 rnd=find_params[2:3]
 shrp=find_params[4:5]
 ap=aper_defaults[0:2]
 gain=aper_defaults[3]

 wgd = where(find_status le 0,ngd)

 result=fltarr(ngd)

;figure out kernel size, for cell padding...  make sure it's odd!
 chk = long(fwhm+.5)

 print,'Reading Source Data: '+fnm[0]
 fits_datmask,fnm[0],imb,hdr,mask
 sz = sxpar(hdr,'NAXIS*')

 for k=0l,ngd-1 do begin
  loc = long(find_dat[0:1,wgd[k]]+.5)
;  diff = find_dat[0:1,wgd[k]]-(loc-chk)+[(loc[0]-chk)-((loc[0]-chk)>0),(loc[1]-chk)-((loc[1]-chk)>0)]
  temp=imb[(loc[0]-1)>0:(loc[0]+1)<(sz[0]-1),(loc[1]-1)>0:(loc[1]+1)<(sz[1]-1)]
  rsz=size(temp)
  w=where(temp eq max(temp))
  loc = loc+[w mod rsz[1],w / rsz[1]]-1-[(loc[0]-1)-((loc[0]-1)>0),(loc[1]-1)-((loc[1]-1)>0)]
;  diff = find_dat[0:1,wgd[k]]-(loc-chk)+[(loc[0]-chk)-((loc[0]-chk)>0),(loc[1]-chk)-((loc[1]-chk)>0)]
  diff=loc - ((loc-chk)>0)

  temp = imb[(loc[0]-chk)>0:(loc[0]+chk)<(sz[0]-1),(loc[1]-chk)>0:(loc[1]+chk)<(sz[1]-1)]
  rsz=size(temp)
  rad = temp*0

  if keyword_set(display) then begin
   wm=where(temp eq max(temp))
   delvarx,pos; & erase
   tvimage,bytscl(temp),/keep,/nointerp,pos=pos
   plot,[wm mod rsz[1]]+.5,[wm / rsz[1]]+.5,/noerase,xran=[0,rsz[1]],yran=[0,rsz[2]],/xsty,/ysty,color=255l,psym=7,pos=pos
   plot,[diff[0]]+.5,[diff[1]]+.5,/noerase,xran=[0,rsz[1]],yran=[0,rsz[2]],/xsty,/ysty,color=255l,psym=6,pos=pos
  endif
  
  for j = 0l,rsz[2]-1 do begin
   for i = 0l,rsz[1]-1 do begin
    rad[i,j] = sqrt((i-diff[0])^2+(j-diff[1])^2)
   endfor
  endfor
  index=0

  s = sort(rad)

  for i = 0l,rsz[rsz[0]+2]-2 do begin
   if rad[s[i]] ne rad[s[i+1]] then begin
    if rad[s[i]] eq rad[s[0]] then begin
     prad = [rad[s[i]]]
     prof = [median(temp[where(rad eq rad[s[i]])])]
    endif else begin
     prad = [prad,rad[s[i]]]
     prof = [prof,median(temp[where(rad eq rad[s[i]])])]
    endelse
   endif
  endfor

;  prof = temp[s]
;  prad = rad[s]

  prof = prof - min(prof)
  outfwhm = pv_fwhm2(prad,prof)
;  if outfwhm le 0 then begin
;   outfwhm = -1
;   err = 1
;  endif else err = 0

  result[k] = outfwhm
 endfor  

 return,result

end
