
pro pv_restore_session,state

 fname = dialog_pickfile(path=(*state).path,dialog_parent=(*state).tlb,$
                         title='PhotVis: Select PhotVis session to restore',$
                         /must_exist)
 if fname eq '' then return

 widget_control,/hourglass

 restore,fname
 
 if n_elements(valid) lt 1 then begin
  huh = dialog_message('ERROR: Invalid PhotVis session file!')
  return
 endif
  
 if (*state).fcfg_id gt 0l then begin
  widget_control,(*state).fcfg_id,/destroy
  (*state).fcfg_id = 0l
 endif

 if (*state).pcfg_id gt 0l then begin
  widget_control,(*state).pcfg_id,/destroy
  (*state).pcfg_id = 0l
 endif

 if (*state).acfg_id gt 0l then begin
  widget_control,(*state).acfg_id,/destroy
  (*state).acfg_id = 0l
 endif

 if n_elements(path) gt 0 then (*state).path = path
 if n_elements(plot_state) gt 0 then (*state).plot_state = plot_state
 if n_elements(plot_params) gt 0 then (*state).plot_params = plot_params
 if n_elements(find_state) gt 0 then (*state).find_state = find_state
 if n_elements(find_params) gt 0 then (*state).find_params = find_params
 if n_elements(find_defaults) gt 0 then (*state).find_defaults = find_defaults
 if n_elements(aper_defaults) gt 0 then (*state).aper_defaults = aper_defaults
 if n_elements(active_obj) gt 0 then (*state).active_obj = active_obj
 if n_elements(centerboxsize) gt 0 then (*state).centerboxsize = centerboxsize
 
 if n_elements(im_name) gt 0 then begin
  if not file_test(im_name) then begin
   huh = dialog_message('No FITS file called '+im_name+'!')
   *(*state).main_dat[0] = dialog_pickfile(/must_exist,get_path=newpath,$
      path=(*state).path,title='PhotVis: Select FITS Image')
   if *(*state).main_dat[0] eq '' then begin
    huh = dialog_message(/info,'PhotVis session restore cancelled')
    return
   endif
   (*state).path = newpath
  endif else begin
   *(*state).main_dat[0] = im_name
  endelse

  pv_fitsread,state
  if n_elements(im_scl) gt 0 then begin
   *(*state).main_disp[1] = im_scl
   *(*state).main_dat[5] = bytscl(*(*state).main_dat[1],min=im_scl[0],max=im_scl[1])
  endif
  if (*state).find_state[0] eq 1 then pv_find_init,state
 endif

 if n_elements(n_objects) gt 0 then (*state).n_objects = n_objects
 widget_control,(*state).label[4],set_value=strtrim((*state).n_objects[0],2)
 if n_elements(find_dat) gt 0 then *(*state).find_dat = find_dat
 if n_elements(find_status) gt 0 then *(*state).find_status = find_status
 if n_elements(aper_dat) gt 0 then *(*state).aper_dat = aper_dat

 if (*state).find_state[1] then begin
  pv_dispcalc,state
  pv_redisplay,(*state).tlb  ;display everything
  pv_sense,state
  for i=0,1 do widget_control,(*state).scale[i],set_value=(*(*state).main_disp[1])[i]
  if (*state).active_obj ge 0 then begin
   f_event = {top:(*state).tlb,x:255l,y:255l}
   pv_photdisp,f_event
  endif
 endif

 widget_control,hourglass=0

end
