;..............................................................................
;
;   This program will generate a header for a fits cube
;
;..............................................................................
pro cubeheader,newheader,naxis1,naxis2,naxis3,b0,db,l0,dl,v0,dv

newheader = "SIMPLE  =                    T /image conforms to FITS standard                 "
newheader = [newheader,"BITPIX  =                   16 /bits per data value                             "]
newheader = [newheader,"NAXIS   =                    3 /number of axes                                  "]
newheader = [newheader,string(format = $
'("NAXIS1  = ",i20," /                                                   ")',naxis1)]
newheader = [newheader,string(format = $
'("NAXIS2  = ",i20," /                                                   ")',naxis2)]
newheader = [newheader,string(format = $
'("NAXIS3  = ",i20," /                                                    ")',naxis3)]
newheader = [newheader,"EXTEND   =                   T /file may contain extensions                     "]
newheader = [newheader,"BSCALE  =              1.00000 /  REAL = TAPE*BSCALE + BZERO                    "]
newheader = [newheader,"BZERO   =              0.00000 /                                                "]
newheader = [newheader,"BUNIT   = 'K                 ' /  UNIT OF TOTAL INTENSITY                       "]
newheader = [newheader,"BLANK   =               -1000  / BLANK VALUE                                    "]
newheader = [newheader,"OBJECT  = 'OBJECT            ' /  SOURCE NAME                                   "]
newheader = [newheader,string(format = $
'("CRVAL1  = ",f20.12," / REF VALUE POINT DEGREE                         ")',v0)]
newheader = [newheader,"CRPIX1  =       1.000000000000 / REF POINT PIXEL LOCATION                       "]
newheader = [newheader,"CTYPE1  = 'km/s              ' / COORD TYPE : VALUE IS DEGR                     "]
newheader = [newheader,string(format = $
'("CDELT1  = ",f20.12," / COORD VALUE INCREMENT WITH KM/S                ")',dv)]
newheader = [newheader,"CROTA1  =       0.000000000000 / NO ROTATION                                    "]
newheader = [newheader,string(format = $
'("CRVAL2  = ",f20.12," / REF VALUE POINT DEGREE                         ")',l0)]
newheader = [newheader,"CRPIX2  =       1.000000000000 / REF POINT PIXEL LOCATION                       "]
newheader = [newheader,"CTYPE2  = 'GLON-CAR          ' / COORD TYPE : VALUE IS DEGR                     "]
newheader = [newheader,string(format = $
'("CDELT2  = ",f20.12," / COORD VALUE INCREMENT WITH COUNT DGR           ")',dl)]
newheader = [newheader,"CROTA2  =       0.000000000000 / NO ROTATION                                    "]
newheader = [newheader,string(format = $
'("CRVAL3  = ",f20.12," / REF VALUE POINT DEGREE                         ")',b0)]
newheader = [newheader,"CRPIX3  =       1.000000000000 / REF POINT PIXEL LOCATION                       "]
newheader = [newheader,"CTYPE3  = 'GLAT-CAR          ' / COORD TYPE : VALUE IS DEGR                     "]
newheader = [newheader,string(format = $
'("CDELT3  = ",f20.12," / COORD VALUE INCREMENT WITH COUNT DGR           ")',db)]
newheader = [newheader,"CROTA3  =       0.000000000000 / NO ROTATION                                    "]

newheader = [newheader,"TELESCOP= 'NFRA 25 Meter     ' /                                                "]
newheader = [newheader,"END     "]
end

