pro hi_make,l1,l2,b1,b2,v1,v2


; find range of l 
    lstart = 5*fix(l1*2.)
    lend = 5*fix(l2*2.+0.99)
    strl = strtrim(string(lstart),2)
    file = "L0000.FIT"
    strlength = strlen(strl)
    strput,file,strl,5-strlength

; open first file and use header to define axes
    fits_read,file,image,header
    fitsaxes,header,v,b,l
    v = v/1000.

; set beginning and end points for b and l
    vstart = max(where(v le v1))
    vend = min(where(v ge v2))
    bstart = max(where(b le b1))
    bend =   min(where(b ge b2))
    if vstart eq -1 then vstart = min(v)
    if vend eq -1 then vend = max(v)
    if bstart eq -1 then bstart = min(b)
    if bend eq -1 then bend = max(b)
    print,"vstart = ",v[vstart],", vend = ",v[vend]
    print,"bstart = ",b[bstart],", bend = ",b[bend]

; initialize index and cube
    index = 0  
    cube = replicate(0,vend-vstart+1,fix(lend-lstart)/5.+1,bend-bstart+1)

    for l = lstart,lend,5 do begin
      strl = strtrim(string(l),2)
      file = "L0000.FIT"  
      strlength = strlen(strl)
      strput,file,strl,5-strlength
      print,file
      fits_read,file,image
      cube[*,index,*] = image[vstart:vend,bstart:bend]
      index = index+1
    endfor
    cubeheader,cubehead,n_elements(cube[*,0,0]),n_elements(cube[0,*,0]),$
               n_elements(cube[0,0,*]),$
               b(bstart),b[1]-b[0],$
               lstart/10.,0.5,$
               v(vstart),v[1]-v[0]
    fits_write,"HI.fits",cube,cubehead 

end
