;---------------------------------------------------------------
;
;   ps_port  - this program creates a portrait format ps file
;              by readind the screen array.
;
;----------------------------------------------------------------

pro ps_port,filename

  xsiz = !d.x_size
  ysiz = !d.y_size
   data = tvrd(0,0,xsiz,ysiz)
   set_plot,'ps'


; set plot size to 22 inches wide
  xsize=22.0 & ysize=22.0*ysiz/xsiz
; psfilename='testplot.ps'


; set parameters to letters size:
; Letter=21.6x27.9 cm (8" x 11")

  dpcm=1000.                      ; dots/cm
  xpaper=21.6                     ; xsize of paper (cm)
  ypaper=27.9                     ; ysize of paper (cm)
  xmargin=2.5                     ; x-border (cm)
  ymargin=2.5                     ; y-border (cm)

  xoffset=(ypaper-xsize)/2.0              ; xoffset: center
  yoffset=(xpaper-ysize)/2.0  
  print,xoffset,yoffset

  px0=xoffset & px1=px0+xsize
  py0=yoffset & py1=py0+ysize
  plotpos=dpcm*[px0,py0,px1,py1]

  set_plot,'ps'
;device,/landscape,xoff=0.,yoff=xpaper+5,xsize=ypaper,ysize=xpaper,/color
  device,bits=8,/schoolbook,font_size=12,/color 
;  loadct,3
  device,encapsulated=0,preview=0
  device,filename=filename

  x=findgen(xsiz) & y=findgen(ysiz)
  plot,x,y,xsty=5,ysty=5,/nodata,/noerase,pos=plotpos,/device
  x0=!x.window(0) & x1=!x.window(1)
  y0=!y.window(0) & y1=!y.window(1)

;
; Use the same max number of colors as you had on the screen
;
; tv,bytscl(map,top=max_color),x0,y0,xsize=x1-x0,ysize=y1-y0,/norm
;
; This works too -- reload the color table, and find out the
; current number of colors
;
; loadct,0
; max_color=!d.n_colors-1


  tv,bytscl(data,top=!d.n_colors-1),x0,y0,xsize=x1-x0,ysize=y1-y0,/norm
 
  device,/close

  print,'PostScript written to: ',filename

  set_plot,'x'

return

end	