
pro irac_hdr_merge,nosip=nosip,longfile=longfile,shortfile=shortfile,outfile=outfile,thresh=thresh

 if not keyword_set(longfile) then f1 = dialog_pickfile(/must_exist,title='Select HDR long EXPTIME mosaic') else f1 = longfile
 if not keyword_set(shortfile) then f2 = dialog_pickfile(/must_exist,title='Select HDR short EXPTIME mosaic') else f2 = shortfile
 if not keyword_set(outfile) then fout = dialog_pickfile(title='Save merged mosaic as') else fout = outfile

 if f1 eq '' or f2 eq '' then begin
  print,'Cancelled...'
  retall
 endif

 fits_datmask,f1,im,hdr,mask

 fits_datmask,f2,im2,hdr2,mask2

 if keyword_set(nosip) then scl = 1. else scl = float(sxpar(hdr,'EXPTIME'))/float(sxpar(hdr2,'EXPTIME'))
 if not keyword_set(thresh) then begin
  if keyword_set(nosip) then thresh = 20. else thresh = 10000./scl
 endif

 sz=size(im)
 sz2=size(im2)

; BS hack for now...  HDR frames should be IDENTICAL, DAMMIT!!  
 if sz[1] - sz2[1] + sz[2] - sz2[2] ne 0 then begin
  ;xyxy,hdr2,hdr,0,0,xoff,yoff
  sz[1] = min([sz[1],sz2[1]])
  sz[2] = min([sz[2],sz2[2]])
 endif
  
 bad=intarr(sz[1]*sz[2])
 wm0 = where(mask2 eq 0 and mask eq 0)
 bad[wm0]=1

 robomean,im-im2*scl,5,.5,avg,avgdev,sdev,bad=bad

 w=where(bad eq 1 and (im2 gt thresh or (mask eq 0 and mask2 gt 0)),nswp)

 if nswp gt 0 then begin
  im[w] = im2[w]*scl
  mask[w] = mask2[w]
 endif else begin
  print,'WARNING: No HDR sustitutions were made!'
 endelse

 fits_datmask,fout,im,hdr,mask,/write 

end

