
; irac_rot - modify warping matrices to derotate images

pro irac_rot,im,hdr,mask,kx,ky,rot1

 if n_elements(kx) eq 0 or n_elements(ky) eq 0 then begin
  kx = fltarr(3,3)
  ky = fltarr(3,3)
  kx[0,1] = 1.
  ky[1,0] = 1.
 endif

; getrot,hdr,rot1
 crpix = [sxpar(hdr,'CRPIX1'),sxpar(hdr,'CRPIX2')]-1

 kx2 = kx*cos(-1*rot1*!pi/180.) + ky*sin(-1*rot1*!pi/180.)
 ky2 = ky*cos(-1*rot1*!pi/180.) - kx*sin(-1*rot1*!pi/180.)

 kx = kx2 & ky = ky2

 kx[0,0] = kx[0,0] - crpix[0]*cos(-1*rot1*!pi/180.) - crpix[1]*sin(-1*rot1*!pi/180.)+crpix[0]

 ky[0,0] = ky[0,0] + crpix[0]*sin(-1*rot1*!pi/180.) - crpix[1]*cos(-1*rot1*!pi/180.)+crpix[1]

 irac_rot_hdr,hdr,rot1

end
